unit Unit1;

interface

uses
    Windows, Messages, SysUtils,
    Classes, Graphics, Controls,
    Forms, Dialogs, dsgnintf,
    StdCtrls, Buttons;

type
    TForm1 = class(TForm)
        Button1: TButton;
        Button2: TButton;
        SpeedButton1: TSpeedButton;
        SpeedButton2: TSpeedButton;
        SpeedButton3: TSpeedButton;
        procedure Button1Click(Sender: TObject);
        procedure Button2Click(Sender: TObject);
        procedure FormCreate(Sender: TObject);
    private
    { Private declarations }
    public
    { Public declarations }
        procedure DesignerOnGetSelectedComponent(sender: TObject; var className: string);
        procedure DesignerOnComponentCreated(Sender: TObject);        
    end;

var
    Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
    form2 := TForm2.create(nil);                                                //It must not have any owner
    form2.setDesignMode(true);
    windows.showwindow(form2.handle, sw_show);                                  //Now you cannot use visible property, because now you are in design-time
    form2.formDesigner.OnGetSelectedComponent := DesignerOnGetSelectedComponent;
    form2.formDesigner.OnComponentCreated:=DesignerOnComponentCreated;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
    b: TButton;
begin
    b := TButton.create(form2);
    b.parent := form2;
end;

procedure TForm1.DesignerOnComponentCreated(Sender: TObject);
begin
    speedbutton1.down:=false;
    speedbutton2.down:=false;
    speedbutton3.down:=false;
end;

procedure TForm1.DesignerOnGetSelectedComponent(sender: TObject;
    var className: string);
begin
	//Here you tell the form designer wich control do you want
    classname := '';
    if speedbutton1.down then classname := 'TBUTTON';
    if speedbutton2.down then classname := 'TEDIT';
    if speedbutton3.down then classname := 'TLABEL';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    left := 0;
    top := 0;
    //You must register the classes you want to create with the form designer
    registerClass(TButton);
    registerClass(TEdit);
    registerClass(TLabel);

    //You must register the default component editor,
    //if not, the right button click over a control will give you an AV
	registerComponentEditor(nil,TDefaultEditor);
end;

end.

